<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Sends mail to customer and merchnat via Templates
'*********************************************************************************

sub TemplateFormatMail (rsOrder, rsitems, merchant, customer)
   Body = ""
   dim Textarray(500)
   dim TextCount
   dim Filename
   dim i
   dim CR
   filename = GetConfig("XMerchantEmail")
   SetupEmailformat filename, merchantemailformat
   SetSess "emailformat", ucase(merchantemailformat)
   'Merchant
   
   '701 - 2011.02.16 - Bug Fix: Email should not convert the crlf to br
   session("templatefrommail") = "Yes"
   ShopTemplateArray Filename, rsOrder, TextArray, TextCount
   session("templatefrommail") = ""

   Merchant = ""
   CR = GetMailCR
   for i = 0 to Textcount -1
      Merchant = Merchant & TextArray(i) & CR
   next
   Merchant = RemoveHtml(Merchant, CR)

   ' Customer
   filename = GetConfig("XCustomerEmail")
   SetupEmailformat filename, customeremailformat
   SetSess "emailformat", ucase(customeremailformat)
   ShopTemplateArray Filename, rsOrder, TextArray, TextCount
   Customer = ""
   for i = 0 to Textcount -1
      Customer = Customer & TextArray(i) & CR
   next
   Customer = RemoveHtml(Customer, CR)
   if GetConfig("xemaillist")<>"" then
      HandleEmailList
   end if
end sub

'read mailing list into an array maillist
'parse to get name, emailaddress and Template
'process the Template
'mail to this person
sub HandleEmailList
   dim i, j
   dim words(10)
   dim wordcount
   dim delimiter
   delimiter = ","
   dim inrecord
   dim firstchar
   dim TemplateFile
   dim OtherPerson
   dim CR, emailformat
   dim mailname, mailaddress, temparray(100)
   dim smsservice, smsfrom, smsphone
   ShopReadEntireFile GetConfig("xemaillist"), maillist, maillistcount, temparray
   if maillistcount = 0 then exit sub
   for i = 0 to maillistcount
      inrecord = maillist(i)
      firstchar = left(inrecord, 1)
      if firstchar = "*" or firstchar = "'" then
      else
         ParseRecord inrecord, words, wordcount, delimiter
         Templatefile = words(2)
         smsservice = words(3)
         if Templatefile<>"" then
            SetupEmailformat Templatefile, emailformat
            SetSess "emailformat", ucase(emailformat)
            if emailformat = "HTML" then
               CR = ""
            else
               CR = GetMailCR
            end if
            ShopTemplateArray Templatefile, rsOrder, TextArray, TextCount
            OtherPerson = ""
            for j = 0 to Textcount -1
               OtherPerson = OtherPerson & TextArray(j) & CR
            next
            if emailformat<>"HTML" then
               OtherPerson = replace(OtherPerson, "<br />", CR)
            end if
            mailname = words(0)
            mailaddress = words(1)
            if GetConfig("xDebug") = "Yes" then
               DebugWrite mailname & " " & mailaddress & " " & TextCount
               DebugWrite OtherPerson
            end if
            if SmsService = "" then
               mailPerson mailname, mailaddress, GetConfig("xemailname"), GetConfig("xemail"), GetConfig("xemailsubject"), OtherPerson, "No"
            else
               smsfrom = GetConfig("xemailname")
               smsphone = words(1) ' phone number
               if GetConfig("xdebug") = "Yes" then
                  DebugWrite "Email list sending sms to " & smsphone & " text=" & otherperson
               end if
               sendsms smsservice, smsfrom, smsphone, otherperson
            end if
         end if
      end if
   next
end sub

sub ParseRecord (record, words, wordcount, delimiter)
   dim pos
   dim recordl
   dim bytex
   dim temprec
   dim maxwords
   dim i
   maxwords = 10
   temprec = record
   dim maxentries
   pos = 1
   wordcount = 0
   ' make sure word array is null
   maxentries = ubound(words)
   for i = 0 to maxentries - 1
      words(i) = ""
   next
   recordl = len(temprec)
   ' first eliminate leading blanks
   do
      bytex = mid(temprec, pos, 1)
      while bytex = " " and pos <= recordl
         pos = pos + 1
         bytex = mid(temprec, pos, 1)

      wend
      ' copy word into word array
      while bytex <> delimiter and pos <= recordl
         words(wordcount) = words(wordcount) & bytex
         pos = pos + 1
         bytex = mid(temprec, pos, 1)

      wend
      wordcount = wordcount + 1
      pos = pos + 1
      if wordcount > maxentries then exit sub
   loop until pos > recordl
end sub

sub FormatOtherMail (Filename, RS, Result)
   ' Use mail on any recordset or table.
   ' Returns Result
   dim Textarray(500)
   dim TextCount
   dim i
   dim emailformat
   dim CR
   SetupEmailformat filename, emailformat
   SetSess "emailformat", ucase(emailformat)
   CR = GetMailCR
   ShopTemplateArray Filename, RS, TextArray, TextCount
   Result = ""
   for i = 0 to Textcount -1
      Result = Result & TextArray(i) & CR
   next
   if emailformat<>"HTML" then
      Result = replace(Result, "<br />", CR)
   end if
end sub

function RemoveHtml(itemname, CR)
   dim workrecord, firstchar, morefields, pos, endpos, length
   dim token
   if ucase(GetSess("emailformat")) = "HTML" then
      RemoveHtml = itemname
      exit function
   end if
   workrecord = replace(itemname, "<br />", CR)
   if GetConfig("xemailRemoveHtml")<>"Yes" then
      RemoveHtml = workrecord
      exit function
   end if
   pos = 1
   morefields = True
   do while morefields = True
      pos = 1
      pos = instr(pos, workrecord, "<")
      if pos > 0 then
         endpos = instr(pos, workrecord, ">")
         if endpos = 0 then
            morefields = false
         else
            length = endpos - pos + 1
            token = mid(workrecord, pos, length)
            workrecord = replace(workrecord, token, "")
         end if
      else
         morefields = false
      end if
   loop
   RemoveHtml = workrecord
end function

sub Setupemailformat (filename, emailformat)
   dim temp
   emailformat = "TEXT"
   if ucase(GetConfig("XEmailFormat"))<>"HTML" then exit sub
   temp = right(filename, 3)
   if ucase(temp) = "TXT" then
      emailformat = "TEXT"
   else
      emailformat = "HTML"
   end if
end sub
%>