<!-- #include file="shopsessionsubs.asp" -->
<!-- #include file="shopsessionconfig.asp" -->
<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' maintains state for VP-ASP using  cookies or session variables
' Cookies are not currently supported
'*********************************************************************************

const CookieKey = "VPASP"

sub initsessionvalues
xautoupdatecartprices = getconfig("xautoupdatecartprices")
xsavesessioncookie = getconfig("xsavesessioncookie")
xsavesessionexpirydays = getconfig("xsavesessionexpirydays")
xsavesessionDatabase = ""
end sub
' save a value in session variable
' if using file sessions also save in Database
sub SetSess (field, value)
   dim newvalue
   '700 - 2010.06.10 - Enhancement: Better session handling while using xsavesession
   if lcase(xsavesession) = "yes" then
      newvalue = value
      if value = "" then newvalue = cookienullvalue ' distinquish nothing from empty
      if xsavesessdualmode = "Yes" then
         session(field) = newvalue
      end if
      if lcase(field) = "currenturl" then
	     '700 - 2010.06.23 - Enhancement: Remove websess parameter from URL
         'newvalue = value & "?websess=" & GetWebSess
         ResponseCookies field, newvalue
      else
         ResponseCookies field, newvalue
      end if
      exit sub
   end if
   ' normal sessions
   session(field) = value
end sub

' Used to save an array in a session varaible.
' Normal sessions don't have a problem by file sessions need to
' know it is an array
sub SetSessA (field, value)
   dim a(3)
   '700 - 2010.06.10 - Enhancement: Better session handling while using xsavesession
   if lcase(xsavesession) = "yes" then
      if xsavesessdualmode = "Yes" then
         session(field) = value
      end if
      ResponseCookiesArray field, value
      exit sub
   end if
   ' normal sessions
   session(field) = value
end sub

' get value from session varaible
' if value is empty and we are using file sessions
' try to get value from Database
' If could be empty because no real value, lost sessions do to
' web farm or timeout
function GetSess (field)
   dim value
   ' try Database
   '700 - 2010.06.10 - Enhancement: Better session handling while using xsavesession
   if lcase(xsavesession) = "yes" then
      if xsavesessdualmode = "Yes" then
         value = session(field)
		 '700 - Bug Fix - 2010.04.27 - Database session fix
		 on error resume next
         if value<>"" then
            if value = cookienullvalue then value = ""
            GetSess = value
            exit function
         end if
      end if
      value = RequestCookies(field)
      if value = cookienullvalue then
         value = ""
      else
         if value = "" then
            if xsavesessdualmode = "Yes" then
               session(field) = cookienullvalue ' next time we will have it in real session variable
            end if
         end if
      end if

      GetSess = value
      exit function
   end if
   ' normal sessions
   value = session(field)
   GetSess = value
end function

' get an array from session varaible
' Normal sessions are not an issue
' File sessions need to know it is an array
' first try real sessions, if they are empty, try file sessions
function GetSessA (field)
   dim dataarea, temparray(100), tempcount, rc
   dim value, i, key, cartcount
   '700 - 2010.06.10 - Enhancement: Better session handling while using xsavesession
   if lcase(xsavesession) = "yes" then
      if xsavesessdualmode = "Yes" then
         value = session(field)
		 on error resume next
		 if trim(value(0)) <> "" then

			if err.number = 0 then
            if isarray(value) then
               GetSessA = value
               exit function
            end if
			end if
			
		 end if
      end if
      key = field
      if ucase(key) = "CARTARRAY" then
         RequestCookieCart field, value, rc
         GetSessA = value
         exit function
      end if
      dataarea = RequestCookies(field)
      if dataarea = "" then
         GetSessA = ""
         exit function
      end if
      ParseRecord dataarea, TempArray, tempcount, "|"
      GetSessA = Temparray
      exit function
   end if
   ' normal sessions
   value = session(field)
   GetSessA = value
end function

sub SetSessionTimeout
   if GetConfig("xSessionTimeout")<>"" then
      session.timeout = GetConfig("xsessiontimeout")
   end if
   '700 - 2010.06.10 - Enhancement: Better session handling while using xsavesession
   if lcase(xsavesession) = "yes" then
      Response.Cookies(cookiekey).expires = date+1
   end if
end sub

sub SaveCustomerDetailsCookie
   dim cookfield
   cookfield = ""
   Buildcookie cookfield, "Firstname", strFirstname
   BuildCookie cookfield, "Lastname", strLastname
   BuildCookie cookfield, "Address", strAddress
   '6.08 - address 2 now saved into cookie
   BuildCookie cookfield, "Address2", strAddress2
   BuildCookie cookfield, "City", strCity
   BuildCookie cookfield, "State", strState
   BuildCookie cookfield, "PostCode", strPostCode
   BuildCookie cookfield, "Country", strCountry
   BuildCookie cookfield, "Company", strCompany
   BuildCookie cookfield, "Website", strWebsite
   BuildCookie cookfield, "Phone", strPhone
   BuildCookie cookfield, "Email", strEmail
   '6.08 - losing customerid on shopcustomer.asp error fix - added IF statement below
   if strCustomerID = "" or isnull(strCustomerID) then
      BuildCookie cookfield, "CustomerID", GetSess("customerid")
   else
      BuildCookie cookfield, "CustomerID", strCustomerID
   end if

   '12/1/2006 - bug fix
   dim tmpstrdiscount
   if isnull(strdiscount) then
      tmpstrdiscount = ""
   else
      tmpstrdiscount = replace(strdiscount, ",", ".")
   end if
   BuildCookie cookfield, "Custdiscount", tmpstrdiscount
   'end fix
   BuildCookie cookfield, "Customertype", strcustomertype

   '6.09 - add other fields to cookie
   if GetConfig("xcustomerotherfields") > "" then
      if instr(GetConfig("xcustomerotherfields"), ",") > 0 then
         dim custfield, tempcustfields
         tempcustfields = split(GetConfig("xcustomerotherfields"), ",")

         for each custfield in tempcustfields
            '6.50.4 Bugs Fix - 08 October 2008
            BuildCookie cookfield, "c_" & trim(custfield), CleanChars(request(trim(custfield)))
         next
      else
         '6.50 - precautionary security fix
         BuildCookie cookfield, "c_" & GetConfig("xcustomerotherfields"), CleanChars(request(GetConfig("xcustomerotherfields")))
      end if
   end if

   Response.Cookies ("CartLogin") = cookfield
   response.cookies("CartLogin").expires = date() + 365
end sub

sub BuildCookie (dataarea, fieldname, fieldvalue)
   if dataarea<>"" then
      dataarea = dataarea & ","
   end if
   if fieldvalue = "" then
      dataarea = dataarea & fieldname & "=" & "???"
   else
      '6.09 - If there is a comma in the customers details, replace with pipe before saving in cookie
      if fieldvalue > "" then
         dataarea = dataarea & fieldname & "=" & replace(fieldvalue, ",", "|")
      else
         dataarea = dataarea & fieldname & "=" & fieldvalue
      end if
   end if
end sub

sub RestoreCustomerDetailsCookie
   dim restored, i
   dim cookfield, pairs(30), paircount, fields(4), fieldcount
   cookfield = request.cookies("CartLogin")
   if cookfield = "" then exit sub
   ParseRecord cookfield, pairs, paircount, ","
   for i = 0 to paircount -1
      ParseRecord pairs(i), fields, fieldcount, "="
      if fields(1) = "???" then
         fields(1) = ""
      end if

      '6.09 - If using comma instead of decimal, replace it before restoring
      if GetConfig("xconverteuropeannumbers") = "Yes" then
         if fields(0) = "Custdiscount" then
            fields(1) = replace(fields(1), ".", ",")
         end if
      end if

      '6.09 - If there is a pipe in the customers details, replace with comma before restoring
      if fields(1) > "" then
         fields(1) = replace(fields(1), "|", ",")
      end if

      'Security Patch - 17 April 2008
      if CleanChars(fields(1)) = "" then
         if fields(1) <> "" then
            'Delete Cookie
            response.cookies("CartLogin").expires = date() -1
            response.cookies("CartLogin") = ""
            'Redirect to Error Page
            ShopError "Error loading data from session: " &server.htmlencode(fields(1))
         end if
      end if
      '--------------------------------------

      SetSess fields(0), fields(1)
   next
   SetSess "Restored", "Yes"
   SetSess "Login", "Yes"
end sub

function ShopLcname
   dim abc, name, i
   abc = array("l", "a", "n", "g", "k", "e", "y")
   for i = 0 to ubound(abc)
      name = name & abc(i)
   next
   shoplcname = name
end function

sub SessSaveCart (field, value, cookiekey, cartdays)
   dim expires
   dim cartcount, arrcount, dataarea, j, countkeyname
   dim keyname
   dim i
   dim CartAttributes
   CartAttributes = cMaxCartAttributes
   expires = date+cartdays
   cartcount = GetSess("CartCount")
   if cartcount = "" or cartcount = 0 then exit sub
   for i = 1 to cartcount
      dataarea = ""
      for j = 1 to CartAttributes
         dataArea = dataarea & value(j, i) & ";"
      next
      keyname = field & cstr(i)
      Response.cookies(Cookiekey) (keyname) = dataarea
      Response.cookies(Cookiekey).expires = expires
   next
   countkeyname = "CartCount"
   Response.cookies(Cookiekey) (countkeyname) = cartcount
   Response.cookies(Cookiekey).expires = expires
end sub

sub SessRestoreCart (field, value, cartcount, cookiekey, rc)
   dim arrcount, dataarea, Temparray(20), tempcount
   dim ArrCart
   dim i, j, keyname, countkeyname
   dim CartAttributes
   CartAttributes = cMaxCartAttributes
   rc = 0
   
   '700 - 2010.05.31 - Enahncement: xmaxcartitems limited to maximum 100
   redim ArrCart(CartAttributes, getconfigxmaxcartitems)
   
   value = ArrCart
   countkeyname = "CartCount"
   cartcount = Request.cookies(Cookiekey) (countkeyname)
   if cartcount = "" or Cartcount = 0 then
      rc = 4
      exit sub
   end if
   
   '700 - 2010.05.31 - Enahncement: xmaxcartitems limited to maximum 100
   redim ArrCart(CartAttributes, getconfigxmaxcartitems)
   
   value = ArrCart
   for i = 1 to cartcount
      keyname = field & cstr(i)
      dataarea = Request.cookies(Cookiekey) (keyname)
      ParseRecord dataarea, TempArray, tempcount, ";"
      for j = 1 to CartAttributes
         value(j, i) = temparray(j -1)
      next
   next
end sub

sub ShopProductcheck
   if GetConfig(shoplcname) = "" then ShopLicenseError
   if GetConfig(shoplcname) = "No" then ShopLicenseError
end sub

' add websess  if using cookies
sub ResponseRedirect (url)
   on error resume next
   '700 - 2010.06.10 - Enhancement: Better session handling while using xsavesession
   if lcase(xsavesession) <> "yes" then
      if dbc.state = adStateOpen then
         ShopCloseDatabase dbc
      end if
      response.redirect url
      exit sub
   end if
   dim pos, newurl, delim, posdelim
   delim = "?"
   newurl = url
   pos = instr(url, "websess")
   posdelim = instr(url, "?")
   if posdelim>0 then
      delim = "&"
   end if

   '700 - 2010.06.23 - Enhancement: Remove websess parameter from URL
   'if pos = 0 then
   '   newurl = newurl & delim & "websess=" & GetWebSess
   'end if

   if dbc.state = adStateOpen then
      ShopCloseDatabase dbc
   end if
   response.redirect newurl
end sub

' add websess to url if using cookies
function AddWebSess (url)
   '700 - 2010.06.10 - Enhancement: Better session handling while using xsavesession
   if lcase(xsavesession) <> "yes" then
      addwebsess = url
      exit function
   end if
   dim pos, newurl, delim, posdelim
   delim = "?"
   newurl = url
   pos = instr(url, "websess")
   posdelim = instr(url, "?")
   if posdelim>0 then
      delim = "&"
   end if

   '700 - 2010.06.23 - Enhancement: Remove websess parameter from URL
   'if pos = 0 then
   '   newurl = newurl & delim & "websess=" & GetWebSess
   'end if

   addwebsess = newurl
end function

sub AddWebSessForm
   '700 - 2010.06.10 - Enhancement: Better session handling while using xsavesession
   if lcase(xsavesession) <> "yes" then exit sub
   CreateHiddenElements
end sub

' add websess to url if using cookies
' create &websess=xxxxxxxx
function AddWebSessLink
   '700 - 2010.06.23 - Enhancement: Remove websess parameter from URL
   exit function
   
   '700 - 2010.06.10 - Enhancement: Better session handling while using xsavesession
   if lcase(xsavesession) <> "yes" then
      addwebsesslink = ""
   else
      '700 - SEO
      if getconfig("xSEODynamicEnable") = "Yes" then
	     addwebsesslink = "?websess=" & GetWebSess
	  else
         addwebsesslink = "&websess=" & GetWebSess
	  end if
   end if
end function

' add websess to url if using cookies
' addsession
sub AddSession
   '700 - 2010.06.23 - Enhancement: Remove websess parameter from URL
   exit sub
   
   dim field
   field = "?"
   '700 - 2010.06.10 - Enhancement: Better session handling while using xsavesession
   if lcase(xsavesession) <> "yes" then exit sub
   response.write field & "websess=" & GetWebSess
end sub

'* Purpose:
'* Grabs the data associated with the UserID and creates
'* hidden form elements.
'* Input: The assigned user id
'* Return: Writes out the form element
'* using the Response object.
sub AddWebSessFormGW (fieldname)
   '700 - 2010.06.10 - Enhancement: Better session handling while using xsavesession
   if lcase(xsavesession) <> "yes" then exit sub
   dim websess
   websess = GetWebSess
   response.write "<INPUT TYPE=""hidden"" NAME=" & chr(34) & fieldname & chr(34) & " VALUE=" & chr(34) & websess & chr(34) & ">" & vbcrlf
end sub

' add websess to url if using cookies
' create ?websess=xxxxxxxx. Replaced addwession
function AddWebSessLinkFirst
   '700 - 2010.06.23 - Enhancement: Remove websess parameter from URL
   exit function
   
   '700 - 2010.06.10 - Enhancement: Better session handling while using xsavesession
   if lcase(xsavesession) <> "yes" then
      addwebsesslinkfirst = ""
   else
      addwebsesslinkfirst = "?websess=" & GetWebSess
   end if
end function
%>