<%option explicit%>
<%response.buffer=true%>
<!--#include file="shop$db.asp"-->
<%ShopOpenDatabase dbc%>
<!--#include file="shopproductcreatesql.asp"-->
<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' General Query of Products based on any field
'*********************************************************************************

'701 - 2010.10.27 - Enhancement: Increase shopquery maxproductfield to 200
const cMaxProductFields = 200

dim allvalues, tmpstr, ustrname, rc, i
dim allvaluues
allvalues = "ALL"
dim keys(100)
dim keyvalues(100)
dim keycount
dim firsttime
dim Words(10)
dim wordcount
dim ProductFields
dim ProductTypes
dim ProductFieldCount
dim fieldtype
dim qTemplate

InitializeSystem
QueryGetProductFields
GetInput ' see what user wants
GenerateSQL dbc ' generate SQL
ShopCloseDatabase dbc
SetSess "wordcount", keycount
SetSessA "Words", keys
SetSess "SQL", SQL

'6.50 - precautionary security fix
qTemplate = CleanChars(Request("Template"))

'6.09 - hide breadcrumb on exd page

'700 - 2010.09.01 - Bug Fix: Shopquery wrongly manipulate search string
dim searchstr
if instr(request.ServerVariables("QUERY_STRING"),"search=yes") > 0 then
   searchstr = ""
else
   searchstr = "search=yes&"
end if

'700 - Paging Navigation - bookmark - passing the bookmark values
'700 - 2010.09.01 - Bug Fix: Shopquery wrongly manipulate search string
if qTemplate = "" then
   if instr(request.ServerVariables("QUERY_STRING"),"bc=") > 0 then
      ResponseRedirect "shopdisplayproducts.asp?"& searchstr &""& request.ServerVariables("QUERY_STRING") &""
   else
      ResponseRedirect "shopdisplayproducts.asp?"& searchstr &"bc=no&"& request.ServerVariables("QUERY_STRING") &""
   end if
else
   if instr(request.ServerVariables("QUERY_STRING"),"bc=") > 0 then
      ResponseRedirect "shopdisplayproducts.asp?"& searchstr &""& request.ServerVariables("QUERY_STRING") &""
   else
      ResponseRedirect "shopdisplayproducts.asp?"& searchstr &"bc=no&"& request.ServerVariables("QUERY_STRING") &""
   end if
end if

sub GetInput
   dim key
   dim strname, strvalue
   keycount = 0
   wordcount = 0
   for each key in Request.form
      strname = key

      '6.50 - precautionary security fix
      strvalue = CleanChars(Request.form(key))

      if strvalue<>"" then
         KeyValues(keycount) = strvalue
         keys(keycount) = strname
         keycount = keycount + 1
      end if
   next
   for each key in Request.Querystring
      strname = key

      '6.50 - precautionary security fix
      strvalue = CleanChars(Request.querystring(key))

      if strvalue<>"" then
         KeyValues(keycount) = strvalue
         keys(keycount) = strname
         keycount = keycount + 1
      end if
   next
end sub

sub GenerateSQL (dbc)
   dim i
   dim rc
   QueryGenerateSQL dbc
end sub

sub OldGenerateSQL
   dim i
   dim rc
   if GetConfig("XProductMultiCategories") = "Yes" then
      OLDQueryGenerateMultiSQL
      exit sub
   end if
   OLDQueryGenerateSQL
end sub

' don't allow bad fields to get into query
sub QueryGetProductFields
   dim fSql
   dim rs
   dim fldname
   dim fieldtype
   ProductFieldCount = GetSess("ProductFieldCount")
   if ProductFieldCount = "" then
      ProductFieldCount = 0
      redim ProductFields(cMaxProductFields)
      redim ProductTypes(cMaxProductFields)
      fsql = "select * from  products"
      Set rs = Server.CreateObject("ADODB.Recordset")
      rs.open fSQL, dbc, adOpenDynamic, adLockOptimistic
      for each fldName in rs.Fields
         ProductFields(productfieldcount) = ucase(fldName.name)
         fieldtype = GetTypeName(fldname.type)
         ProductTypes(productfieldcount) = fieldtype
         if lcase(productfields(productfieldcount))<>"Template" then
            Productfieldcount = Productfieldcount + 1
         end if
      next
      CloseRecordSet rs
      SetSessA "ProductFields", ProductFields
      SetSessA "ProductTypes", ProductTypes
      SetSess "ProductFieldCount", ProductFieldCount
   end if
   ProductFields = GetSessA("ProductFields")
   ProductTypes = GetSessA("ProductTypes")
   ProductFieldCount = GetSess("ProductFieldCount")
end sub

sub CheckValIDField (fieldname, rc, fieldtype)
   rc = 0
   for i = 0 to ProductFieldcount -1
      if fieldname = ProductFields(i) then
         fieldtype = ProductTypes(i)
         exit sub
      end if
   next
   select case fieldname
      case "LOWPRICE"
         rc = 0
         fieldtype = "Currency"
         exit sub
      case "CPRICE"
         rc = 0
         fieldtype = "Currency"
         exit sub
   end select
   rc = 4
end sub

function GetTypeName(id)
   select case id
      case "3"
         GetTypeName = "Number"
      case "200"
         GetTypeName = "Text"
      case "129"
         GetTypeName = "Text"
      case "201"
         GetTypeName = "Memo"
      case "6"
         GetTypeName = "Currency"
      case "11"
         GetTypeName = "YesNo"
      case "5"
         GetTypeName = "Number"
      case "7", "133", "134", "135"
         GetTypeName = "DateTime"
      case else
         GetTypeName = "Text"
   end select
end function
%>