<!-- #include file="fusioncharts/FusionCharts.asp" -->
<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Report routines
'*********************************************************************************

sub GetDateValues
   dim datevalue
   FromDate = request("FromDateyy") & "/" & request("FromDatemm") & "/" & request("FromDatedd")
   Todate = request("Todateyy") & "/" & request("Todatemm") & "/" & request("Todatedd")
   if FromDate<>"" and cstr(fromdate) <> "0/0/0" then
      if Todate = "" then
         Todate = date()
      end if
      ValidateDates
      exit sub
   end if
   ' Try month
   month = Request("month")
   year = Request("Year")

   if month>"0" then
      FormatMonth
      exit sub
   end if
   if year>"0" then
      FormatYear
      exit sub
   end if
   ' Try Radio Buttons
   datevalue = request("DateSelect")
   datevalue = ucase(datevalue)
   if datevalue = "" then
      SError = GetLang("langReportDate")
      exit sub
   end if
   if datevalue = "TODAY" then
      FromDate = date()
      Todate = date()
	  '701. 2012.03.12 - Bug Fix: Date search criteria "Today" and "Yesterday" should follow xtimedifference
      Adjustdate FromDate
      Adjustdate Todate
      exit sub
   end if
   if datevalue = "YESTERDAY" then
      '701. 2012.03.12 - Bug Fix: Date search criteria "Today" and "Yesterday" should follow xtimedifference
      'FromDate = dateadd("d", -1, date())
      'Todate = FromDate
      FromDate = date()
      Adjustdate FromDate
      FromDate = dateadd("d", -1, FromDate)
      Todate = FromDate
      exit sub
   end if
end sub

sub ValidateDates
   if not isdate(FromDate) then
      SError = GetLang("langReportInvalidDate") & FromDate
   end if
   if not isdate(Todate) then
      SError = "<br />" & GetLang("langReportInvalidDate") & Todate
   end if
   if FromDate = "" and Todate = "" then
      SError = GetLang("LangReportDate")
   end if
   if SError = "" then
      SetSess "FromDate", FromDate
      SetSess "Todate", Todate
   end if
end sub

sub FormatMonth
   if lcase(GetConfig("xenvironment")) = "chillisoft" then
      FormatMonthchilli
      exit sub
   end if
   month = cint(month)
   if year = "0" then
      year = datepart("yyyy", date())
   else
      year = clng(year)
   end if
   FromDate = month & "/" & year
   month = month + 1
   if month = 13 then
      month = 1
      year = year + 1
   end if
   Todate = month & "/" & year
   FromDate = cdate(FromDate)
   Todate = cdate(Todate)
   Todate = dateadd("d", -1, Todate)
end sub

sub FormatYear
   if lcase(GetConfig("xenvironment")) = "chillisoft" then
      FormatYearchilli
      exit sub
   end if
   year = clng(year)
   month = 1
   FromDate = month & "/" & year
   year = year + 1
   Todate = month & "/" & year
   FromDate = cdate(FromDate)
   Todate = cdate(Todate)
   Todate = dateadd("d", -1, Todate)
end sub

sub FormatMonthChilli
   month = cint(month)
   if year = "0" then
      year = datepart("yyyy", date())
   else
      year = clng(year)
   end if
   FromDate = month & "/1" & "/" & year
   month = month + 1
   if month = 13 then
      month = 1
      year = year + 1
   end if
   Todate = month & "/1" & "/" & year
   FromDate = cdate(FromDate)
   Todate = cdate(Todate)
   Todate = dateadd("d", -1, Todate)
end sub

sub FormatYearChilli
   year = clng(year)
   month = 1
   FromDate = month & "/" & "01/" & year
   year = year + 1
   Todate = month & "/01/" & year
   FromDate = cdate(FromDate)
   Todate = cdate(Todate)
   Todate = dateadd("d", -1, Todate)
end sub

'700 - Reports - Get Month Name
function GetMonthShortName (pmonth)
   select case cint(pmonth)
      case 1
	     GetMonthShortName = "Jan"
	  case 2
	     GetMonthShortName = "Feb"
	  case 3
	     GetMonthShortName = "Mar"
	  case 4
	     GetMonthShortName = "Apr"
	  case 5
	     GetMonthShortName = "May"
	  case 6
	     GetMonthShortName = "Jun"
	  case 7
	     GetMonthShortName = "Jul"
	  case 8
	     GetMonthShortName = "Aug"
	  case 9
	     GetMonthShortName = "Sep"
	  case 10
	     GetMonthShortName = "Oct"
	  case 11
	     GetMonthShortName = "Nov"
	  case 12
	     GetMonthShortName = "Dec"
   end select
end function

'700 - Reports - Get Bar Color
function GetBarColor (pvalue)
   select case cstr(pvalue)
      case "1"
		 GetBarColor = GetConfig("xChart2DBarColor01")
	  case "2"
		 GetBarColor = GetConfig("xChart2DBarColor02")
	  case "3"
		 GetBarColor = GetConfig("xChart2DBarColor03")
	  case "4"
		 GetBarColor = GetConfig("xChart2DBarColor04")
	  case "5"
		 GetBarColor = GetConfig("xChart2DBarColor05")
	  case "6"
		 GetBarColor = GetConfig("xChart2DBarColor06")
	  case "7"
		 GetBarColor = GetConfig("xChart2DBarColor07")
	  case "8"
		 GetBarColor = GetConfig("xChart2DBarColor08")
	  case "9"
		 GetBarColor = GetConfig("xChart2DBarColor09")
	  case "10"
		 GetBarColor = GetConfig("xChart2DBarColor10")
	  case "11"
		 GetBarColor = GetConfig("xChart2DBarColor11")
	  case "12"
		 GetBarColor = GetConfig("xChart2DBarColor12")
      case else
	     GetBarColor = ""
   end select
end function
%>